require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ENDIAN_H)) {
    eval 'sub _MACHINE_ENDIAN_H () {1;}' unless defined(&_MACHINE_ENDIAN_H);
    require '386/endian.ph';
    unless(defined(&_UINT16_T_DECLARED)) {
	eval 'sub _UINT16_T_DECLARED () {1;}' unless defined(&_UINT16_T_DECLARED);
    }
    unless(defined(&_UINT32_T_DECLARED)) {
	eval 'sub _UINT32_T_DECLARED () {1;}' unless defined(&_UINT32_T_DECLARED);
    }
    unless(defined(&_UINT64_T_DECLARED)) {
	eval 'sub _UINT64_T_DECLARED () {1;}' unless defined(&_UINT64_T_DECLARED);
    }
    eval 'sub bswap16 {
        my($x) = @_;
	    eval q( &__bswap16($x));
    }' unless defined(&bswap16);
    eval 'sub bswap32 {
        my($x) = @_;
	    eval q( &__bswap32($x));
    }' unless defined(&bswap32);
    eval 'sub bswap64 {
        my($x) = @_;
	    eval q( &__bswap64($x));
    }' unless defined(&bswap64);
    if((defined(&_BYTE_ORDER) ? &_BYTE_ORDER : undef) == (defined(&_LITTLE_ENDIAN) ? &_LITTLE_ENDIAN : undef)) {
	eval 'sub htobe16 {
	    my($x) = @_;
    	    eval q( &bswap16(($x)));
	}' unless defined(&htobe16);
	eval 'sub htobe32 {
	    my($x) = @_;
    	    eval q( &bswap32(($x)));
	}' unless defined(&htobe32);
	eval 'sub htobe64 {
	    my($x) = @_;
    	    eval q( &bswap64(($x)));
	}' unless defined(&htobe64);
	eval 'sub htole16 {
	    my($x) = @_;
    	    eval q((( &uint16_t)($x)));
	}' unless defined(&htole16);
	eval 'sub htole32 {
	    my($x) = @_;
    	    eval q((( &uint32_t)($x)));
	}' unless defined(&htole32);
	eval 'sub htole64 {
	    my($x) = @_;
    	    eval q((( &uint64_t)($x)));
	}' unless defined(&htole64);
	eval 'sub be16toh {
	    my($x) = @_;
    	    eval q( &bswap16(($x)));
	}' unless defined(&be16toh);
	eval 'sub be32toh {
	    my($x) = @_;
    	    eval q( &bswap32(($x)));
	}' unless defined(&be32toh);
	eval 'sub be64toh {
	    my($x) = @_;
    	    eval q( &bswap64(($x)));
	}' unless defined(&be64toh);
	eval 'sub le16toh {
	    my($x) = @_;
    	    eval q((( &uint16_t)($x)));
	}' unless defined(&le16toh);
	eval 'sub le32toh {
	    my($x) = @_;
    	    eval q((( &uint32_t)($x)));
	}' unless defined(&le32toh);
	eval 'sub le64toh {
	    my($x) = @_;
    	    eval q((( &uint64_t)($x)));
	}' unless defined(&le64toh);
    } else {
	eval 'sub htobe16 {
	    my($x) = @_;
    	    eval q((( &uint16_t)($x)));
	}' unless defined(&htobe16);
	eval 'sub htobe32 {
	    my($x) = @_;
    	    eval q((( &uint32_t)($x)));
	}' unless defined(&htobe32);
	eval 'sub htobe64 {
	    my($x) = @_;
    	    eval q((( &uint64_t)($x)));
	}' unless defined(&htobe64);
	eval 'sub htole16 {
	    my($x) = @_;
    	    eval q( &bswap16(($x)));
	}' unless defined(&htole16);
	eval 'sub htole32 {
	    my($x) = @_;
    	    eval q( &bswap32(($x)));
	}' unless defined(&htole32);
	eval 'sub htole64 {
	    my($x) = @_;
    	    eval q( &bswap64(($x)));
	}' unless defined(&htole64);
	eval 'sub be16toh {
	    my($x) = @_;
    	    eval q((( &uint16_t)($x)));
	}' unless defined(&be16toh);
	eval 'sub be32toh {
	    my($x) = @_;
    	    eval q((( &uint32_t)($x)));
	}' unless defined(&be32toh);
	eval 'sub be64toh {
	    my($x) = @_;
    	    eval q((( &uint64_t)($x)));
	}' unless defined(&be64toh);
	eval 'sub le16toh {
	    my($x) = @_;
    	    eval q( &bswap16(($x)));
	}' unless defined(&le16toh);
	eval 'sub le32toh {
	    my($x) = @_;
    	    eval q( &bswap32(($x)));
	}' unless defined(&le32toh);
	eval 'sub le64toh {
	    my($x) = @_;
    	    eval q( &bswap64(($x)));
	}' unless defined(&le64toh);
    }
}
1;
